﻿using PDFXCoreAPI;
using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace DeletePagesTest
{
    public partial class Form1 : Form
    {
        private PXC_Inst mTrackerInstance = new PXC_Inst();
        private string mTrackerApiKey = "";

        public Form1()
        {
            mTrackerInstance.Init(mTrackerApiKey);
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //mTrackerInstance.Init(mTrackerApiKey);
            //mTrackerInstance.SetMemoryLimit(980);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            mTrackerInstance.Finalize();
            mTrackerInstance = null;
            GC.Collect();
            GC.WaitForPendingFinalizers();
        }

        private void btnSelectFile_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string lsInput = openFileDialog1.FileName;
                string lsOutput = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Desktop), "MyOutput.pdf");

                if (File.Exists(lsOutput))
                {
                    File.Delete(lsOutput);
                }

                IPXC_Document loDoc = null;
                string lsResult = string.Empty;

                try
                {
                    // check if there are any pages to delete
                    if (string.IsNullOrEmpty(txtPages.Text))
                    {
                        MessageBox.Show("No pages to delete.");
                        return;
                    }

                    // split the pages
                    string[] lsPages = txtPages.Text.Split(',');

                    // load pdf file
                    loDoc = mTrackerInstance.OpenDocumentFromFile(lsInput, null);

                    int liCurrentPageCount = (int)loDoc.Pages.Count;
                    IAUX_Inst loAuxInst = mTrackerInstance.GetExtension("AUX");

                    //for (int i = 0; i < lsPages.Length; i++)
                    //{
                    //    // delete the current page
                    //    if ((Convert.ToInt32(lsPages[i]) - i) < liCurrentPageCount)
                    //    {
                    //        IBitSet loIndex = loAuxInst.CreateBitSet((uint)liCurrentPageCount);
                    //        IPXC_UndoRedoData loUndoRedoData;// = null;

                    //        loIndex.Set((uint)(Convert.ToInt32(lsPages[i]) - i), 1);
                    //        loDoc.Pages.DeletePages(loIndex, null, out loUndoRedoData);

                    //        loUndoRedoData = null;
                    //        loIndex = null;
                    //    }

                    //    // reduce the page count by 1
                    //    liCurrentPageCount--;
                    //}

                    IAUX_Inst auxInst = (IAUX_Inst)mTrackerInstance.GetExtension("AUX");
                    IBitSet bs = auxInst.CreateBitSet(1);
                    bs.Set(0);
                    IPXC_Pages loPages = loDoc.Pages;
                    IPXC_UndoRedoData urd = null;
                    if (loPages.Count > 1)
                        loPages.DeletePages(bs, null, out urd);
                    Marshal.ReleaseComObject(loPages);
                    //else
                    //MessageBox.Show("The last page can't be removed from the document!");

                    //IBitSet loIndex = loAuxInst.CreateBitSet((uint)liCurrentPageCount);
                    //IPXC_UndoRedoData loUndoRedoData;// = null;

                    //loIndex.Set(0, 1);
                    //loDoc.Pages.DeletePages(loIndex, null, out loUndoRedoData);

                    // save the pdf file
                    //oCoreApi.SavePdfFile(fileName, ref loDoc);
                    loDoc.WriteToFile(lsOutput);
                    

                    loAuxInst = null;
                    MessageBox.Show("Success");
                    //loDoc = null;
                }
                catch (Exception loExpection)
                {
                    //if (loDoc != null)
                    //{
                    //    loDoc.Close();
                    //    loDoc = null;
                    //}

                    lsResult = "[Error]: " + loExpection.Message;
                }
                finally
                {
                    if (loDoc != null)
                    {
                        loDoc.Close();
                        loDoc = null;
                    }
                }
            }
            else
            {
                MessageBox.Show("Please select a valid file.");
            }
        }
    }
}
